
;angular.module('Landers.angular')
    .directive('buttonCheckbox', ['$timeout', 'Flat', 'Helpers',  function($timeout, Flat, Helpers){
        var $event_button;
        return {
            restrict : 'A',
            link : function($scope, $group, $attrs) {
                var myScope = Helpers.seekScope($scope, $attrs['useScope']);
                var on_watch = $attrs['buttonCheckboxOnWatch'];
                if ( on_watch ) {
                    on_watch = Flat.get($scope, on_watch);
                }
                var ngModel = $attrs['ngModel'];
                var classActive = 'active';

                $scope.$watch(ngModel, function(values){
                    if ( !values ) return;
                    $timeout(function(){
                        var $inputs = $group.find('[type=checkbox]');
                        $inputs.each(function(){
                            var $input = $(this);
                            var val = $input.val();
                            var index = $.inArray(val.toString(), values);
                            if ( index >= 0) {
                                $input.parent().addClass(classActive);
                                $input.prop('checked', true)
                            } else {
                                $input.parent().removeClass(classActive);
                                $input.prop('checked', false)
                            }
                        });

                        if (on_watch) {
                            on_watch(values, $event_button);
                        }
                    }, 100)
                });

                var doActive = function($_event_button){
                    $event_button = $_event_button;
                    var $buttons = $group.children(), $input;
                    var values = [];

                    $timeout(function(){
                        $buttons.each(function(){
                            var $button = $(this);
                            if ($button.hasClass('disabled') || $button.prop('disabled') || $button.attr('disabled')) {
                                return;
                            }
                            $input = $button.children();
                            if ( $input.prop('checked') ) {
                                values.push($input.val());
                            }
                        });
                        Flat.set(myScope, ngModel, values);

                        var a = ngModel.split('.');
                        a.splice(1, 0, '$errors');
                        var errorKey = a.join('.');
                        Flat.set(myScope, errorKey, '');

                        if (!myScope.$$phase) myScope.$apply();
                    }, 100);
                };

                var ngModelList = $attrs['ngModelList'];
                if (ngModelList) {
                    $scope.$watch(ngModelList, function(value){
                        var $buttons = $group.children();

                        $buttons.unbind('click').click(function(){
                            doActive($(this));
                        });
                    });
                } else {
                    (function(){
                        var $buttons = $group.children();
                        if ( !$buttons.length ) {
                            return setTimeout(arguments.callee, 300);
                        }

                        $buttons.click(function(){
                            doActive($(this));
                        });
                    })();
                }
            }
        };
    }]);