;angular.module('Landers.angular')
    .directive('buttonRadio', ['$timeout', 'Flat', 'Helpers',  function($timeout, Flat, Helpers){
        return {
            restrict : 'A',
            link : function($scope, $group, $attrs) {
                var myScope = Helpers.seekScope($scope, $attrs['useScope']);
                var on_watch = $attrs['buttonRadioOnWatch'];
                var ngModel = $attrs['ngModel'];
                if ( on_watch ) {
                    on_watch = Flat.get($scope, on_watch);
                    $scope.$watch(ngModel, function(new_value){
                        if ( new_value === undefined ) return;
                        on_watch(new_value);
                    });
                }

                var doActive = function($button){
                    if ($button.hasClass('disabled') || $button.prop('disabled') || $button.attr('disabled')) {
                        return false;
                    }
                    var $input = $button.children();
                    Flat.set(myScope, ngModel, $input.val());

                    var a = ngModel.split('.');
                    a.splice(1, 0, '$errors');
                    var errorKey = a.join('.');
                    Flat.set(myScope, errorKey, '');

                    if (!myScope.$$phase) myScope.$apply();

                    return true;
                };

                var ngModelList = $attrs['ngModelList'];
                if (ngModelList) {
                    $scope.$watch(ngModelList, function(value){
                        var $buttons = $group.children();

                        $buttons.unbind('click').click(function(){
                            return doActive($(this));
                        });

                    });
                } else {
                    (function(){
                        var $buttons = $group.children();
                        if ( !$buttons.length ) {
                            return setTimeout(arguments.callee, 300);
                        }

                        $buttons.click(function(){
                            return doActive($(this));
                        });
                    })();
                }
            }
        };
    }]);