;angular.module('Landers.angular')
    .directive('ngUploader', ['$timeout', '$compile', 'Upload', 'Helpers', 'Flat',  function($timeout, $compile, Upload, Helpers, Flat){
        var counter = 0;
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs){
                if ($ele.data('uploadId')) return;

                var uploadId = 'uploadFiles' + (counter++);

                //将uploadId暴露到外面，以便外部可以控制调用
                $ele.data('uploadId', uploadId);

                var ngmodel = $attrs['ngModel'];

                var upload_url = $attrs['uploadUrl'];
                upload_url = Helpers.domainUrl(ENV.hosts.storage, upload_url);

                var onUpload = $attrs['onUpload'];
                var onReset = $attrs['onReset'];

                var props = [], tip = [];

                var accept = $attrs['accept'];
                if (accept) props.push('accept="'+ accept +'"');

                var ngf_max_width = $attrs['ngfMaxWidth'];
                if (ngf_max_width) {
                    props.push('ngf-max-width="'+ ngf_max_width +'"');
                }

                var ngf_max_height = $attrs['ngfMaxHeight'];
                if (ngf_max_height) {
                    props.push('ngf-max-height="'+ ngf_max_height +'"');
                }

                var ngf_max_size = $attrs['ngfMaxSize'];
                if (ngf_max_size) {
                    props.push('ngf-max-size="'+ ngf_max_size +'"');
                    tip.push('文件大小不超过' + ngf_max_size);
                }

                var upload_class = $attrs['uploadClass'];
                if (upload_class) props.push('class="'+ upload_class +'"');

                props = props.join(' ');
                tip = tip.join('，');
                tip = '选择上传附件' + (tip.length ? '，' + tip : '' );

                var html = '';
                html += '<input type="hidden" ng-model="' + ngmodel + '" class="form-control">';
                html += '<button type="file" ngf-select="$upload.' + uploadId + '.upload($file, $invalidFiles)" ' + props + '>' + tip + '</button>';
                html += '<div class="progress upload-progress" ng-show="$upload.' + uploadId + '.f.progress>0">';
                html += '   <div class="progress-bar progress-bar-info" role="progressbar" aria-valuenow="80" aria-valuemin="0" aria-valuemax="100" style="width: {{$upload.' + uploadId + '.f.progress}}%">';
                html +=         '<span class="sr-only" ng-bind="$upload.' + uploadId + '.f.progress + \'%\'"></span>';
                html += '   </div>';
                html += '</div>';
                $ele.append($compile(html)($scope));

                //upload的命名空间
                $scope.$upload = $scope.$upload || {};
                var $UL = $scope.$upload;
                $UL[uploadId] = {
                    tip : tip,
                    event : $ele.find('button'),
                    onUpload : onUpload ? Flat.get($scope, onUpload) : null,
                    onReset : onReset ? Flat.get($scope, onReset) : null,
                    upload : function(file, errFiles){
                        var _this = this;
                        var $event = _this.event;

                        if (errFiles && errFiles.length) {
                            var message, errFile = errFiles[0];
                            switch (errFile.$error) {
                                case 'maxSize' :
                                    message = '文件大小不能超过' + errFile.$errorParam;
                                    break;
                                case 'maxWidth' :
                                    message = '图片宽度不能超过' + errFile.$errorParam + 'px';
                                    break;
                                case 'maxHeight' :
                                    message = '图片高度不能超过' + errFile.$errorParam + 'px';
                                    break;
                                default :
                                    message = errFile.$error + errFile.$errorParam;
                                    break;
                            }
                            return Landers.response.msgbox({
                                success : false,
                                message : message
                            });
                        }


                        if (file) {
                            $UL[uploadId].f = file;
                            file.upload = Upload.upload({
                                url: upload_url,
                                data: {file: file}
                            });
                            file.upload.then(
                                function (response) {
                                    $timeout(function () {
                                        $UL.uploading = false;
                                        file.result = response.data;
                                        Flat.set($scope, ngmodel, file.result.data.url);
                                        _this.onUpload && _this.onUpload(file.result.data);
                                        Helpers.enable($event).text('上传成功');
                                    }, 200);
                                },
                                function (response) {
                                    $timeout(function () {
                                        $UL.uploading = false;
                                        if (response.status > 0) {
                                            $UL.errorMsg = response.status + ': ' + response.data;
                                        }
                                        Helpers.enable($event).text('上传失败');
                                    }, 200);
                                },
                                function (evt) {
                                    $UL.uploading = true;
                                    file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                                    Helpers.disable($event).text('已上传' + file.progress + '%...，请稍候...');
                                }
                            );
                        }

                    },
                    reset : function(){
                        var _this = this;
                        var $event = _this.event;
                        Flat.set($scope, ngmodel, '');
                        $event.text(_this.tip);
                        _this.onReset && _this.onReset(file.result.data);
                    }
                };
            }
        };
    }]);